#!/usr/bin/env python
#-*- coding: utf-8 -*-

import sys
from analog1 import parse_apache_log, fmt

def get_by_strict_match(logfile, string, field):
    for line in parse_apache_log(logfile, fmt):
        if line[field] == string:
            yield line

def get_by_status(logfile, status):
    return get_by_strict_match(logfile, status, 'status')

def get_by_host(logfile, host):
    return get_by_strict_match(logfile, host, 'host')


def get_by_partial_match(logfile, string, field):
    for line in parse_apache_log(logfile, fmt):
        if line[field].find(string) == 0:
            yield line

def get_by_request(logfile, request):
    request = request.split('?')[0]
    return get_by_partial_match(logfile, request, 'request')

def get_by_datetime(logfile, datetime):
    return get_by_partial_match(logfile, datetime, 'time')

get_by_min = get_by_datetime
get_by_hour = get_by_datetime
get_by_day = get_by_datetime
