#!/usr/bin/env python
#-*- coding: utf-8 -*-

"""
génère un fichier <nom_fichier>.ano dans lequel les adresses IP
sont anonymisées.
L'adresse IP doit être en début de ligne.
"""

import sys
from random import randint

def get_random_ip():
    """Anonymiseur d'IP"""
    return ".".join((str(randint(10, 254)) for i in range(4)))

def anon_file(filename):
    """Retourne une à une chaque ligne du fichier après avoir
    anonymisé l'IP.
    """
    # le dico des ip anonymisées
    d_aip = {}
    with open(filename) as f:
        for line in f:
            ip, rline = line.strip().split(" ", 1)
            if not ip in d_aip:
                d_aip[ip] = get_random_ip()
            yield "{} {}".format(d_aip[ip], rline)

if __name__ == '__main__':
    filename = sys.argv[1]
    a_filename = "{}.ano".format(filename)
    with open(a_filename, "w") as sf:
        for line in anon_file(filename):
            sf.write("{}\n".format(line))
