#!/usr/bin/env python
#-*- coding: utf-8 -*-

import sys

class Ls:
    def __init__(self, ls_line):
        ls_list = ls_line.split()
        self.rights = ls_list[0]
        self.nlinks = ls_list[1]
        self.owner = ls_list[2]
        self.group = ls_list[3]
        self.size = int(ls_list[4])
        self.month = ls_list[5]
        self.day = ls_list[6]
        self.hour = ls_list[7]
        self.name = ls_list[8]

class Bundle:
    def __init__(self, directory):
        self.__dir = directory
        with open('{}/ls'.format(self.__dir)) as f:
            self.__lss = [Ls(ls_line) for ls_line in f]
        self.__filenames = [ls.name for ls in self.__lss]

    def list(self):
        for ls in self.__lss:
            print("{}: {}".format(ls.name, ls.size))

    def __index(self, filename):
        return self.__filenames.index(filename)

    def __offset(self, filename):
        offset = 0
        for i in range(self.__index(filename)):
            offset += self.__lss[i].size
        return offset

    def __size(self, filename):
        return self.__lss[self.__index(filename)].size

    def __content(self, filename):
        """Le contenu retourné est de type "bytes"
        """
        with open('{}/bundle'.format(self.__dir), "rb") as f:
            offset = self.__offset(filename)
            size = self.__size(filename)
            f.seek(offset)
            return f.read(size)

    def write(self, filename):
        assert(filename in self.__filenames)
        open("{}/{}".format(self.__dir, filename), "wb").write(
            self.__content(filename))

    def cat(self, filename):
        """Le contenu (bytes) est décodé avant d'être affiché
        """
        assert(filename in self.__filenames)
        print(self.__content(filename).decode("utf-8"))

bundle = Bundle(sys.argv[1])
if len(sys.argv) == 2:
    bundle.list()
elif len(sys.argv) == 3:
    bundle.cat(sys.argv[2])
