###############################################################################
# The communication module (communication.py)
###############################################################################

"""
http://code.activestate.com/recipes/531824-chat-server-client-using-selectselect/
"""

import socket
import struct
import json

def send(channel, *args):
    buf = json.dumps(args)
    value = socket.htonl(len(buf))
    size = struct.pack("L",value)
    channel.send(size)
#    print("SENT: {}".format(buf))
    if not type(buf) is bytes:
        buf = bytes(buf, "utf-8") # Python3
    channel.send(buf)

def receive(channel):
    size = struct.calcsize("L")
    size = channel.recv(size)
    try:
        size = socket.ntohl(struct.unpack("L", size)[0])
    except struct.error as e:
        return ''

    buf = ""
    while len(buf) < size:
        buf = channel.recv(size - len(buf))
#    print("RECEIVED: {}".format(buf))
    return json.loads(buf.decode("utf-8"))[0]
