#!/usr/bin/env python
#-*- coding: utf-8 -*-

import sys

#from wsgiref.util import setup_testing_defaults
from wsgiref.simple_server import make_server

log_path = "/home/joel/TPPYTHON/AnaLog/"
logfile = '{}/jdm_access.log'.format(log_path)
sys.path.insert(0, log_path)

import analogmod

mode_emploi = """
<h1>Mode d'emploi</h1>
<ul>
<li>/status/&lt;status number&gt;</li>
<li>/request/&lt;request&gt;</li>
<li>/host/&lt;ip&gt;</li>
<li>/time/&lt;datetime&gt;</li>
</ul>
"""

def a(line, op):
    elt = line[op]
    return """<a href="/{}/{}">{}</a>""".format(op, elt, elt)

def to_html(line):
    return "<tr>{}</tr>".format("<td>{}</td>".format(
        "</td><td>".join(
            (a(line, 'host'), a(line, 'time'),
             a(line, 'request'), a(line, 'status')
            )
        )
    )).encode("utf-8")

def simple_app(environ, start_response):
    global mode_emploi
    d_op = {
        'status': analogmod.get_by_status,
        'request': analogmod.get_by_request,
        'host': analogmod.get_by_host,
        'time': analogmod.get_by_datetime
    }

#    setup_testing_defaults(environ)

    status = '200 OK'
    headers = [('Content-type', 'text/html; charset=utf-8')]

    start_response(status, headers)

    path_info = environ['PATH_INFO']

    if path_info:
        try:
            key, value = path_info.split('/', 2)[1:]
            ret = ["<table>".encode("utf-8")]
            ret += [to_html(line) for line in d_op[key](logfile, value)]
            ret.append("</table>".encode("utf-8"))
            return ret
        except Exception as err:
            return [mode_emploi.encode("utf-8")] + [str(err).encode("utf-8")]

httpd = make_server('', 8001, simple_app)
print("Serving on port 8001...")
httpd.serve_forever()
